﻿#Include <String.au3>
#Include <_ClipGetHTML.au3>
#Include <_ClipPutHTML.au3>

; WARNING !!! ONLY EDIT THE AU3 FILE IN AKELPAD
; 
; _HexToString malfunctions on my Windows 7 computer, so this is the alternative
; but it's important, then, to edit the AU3 file in a Unicode editor only.

Global $oldclip

$nonbreaker = " " ; _HexToString("a0")
$endasher = "–" ; _HexToString("96")
$emdasher = "—" ; _HexToString("97")
$dotter = "…" ; _HexToString("85")
$singleopenquote = "‘" ; _HexToString("91")
$singleclosequote = "’" ; _HexToString("92")
$doubleopenquote = "“" ; _HexToString("93")
$doubleclosequote = "”" ; _HexToString("94")

MsgBox (0, "Eight keyboard shortcuts for Idiom translators, version 6", "Shift+Ctrl+Space = non-breaking space" & @CRLF & "Alt+Ctrl+fullstop = ellips (...)" & @CRLF & "Ctrl+NumMinus = en-dash" & @CRLF & "Shift+Ctrl+NumMinus = em-dash" & @CRLF & @CRLF & "Ctrl+( = single opening quote" & @CRLF & "Ctrl+) = single closing quote (or curly apostrophe)" & @CRLF & "Ctrl+Shift+( = double opening quote" & @CRLF & "Ctrl+Shift+) = double closing quote" & @CRLF & @CRLF & "The non-breaking space may not work in a browser text field." & @CRLF & @CRLF & "To exit the script, press Shift+Ctrl+Alt+Q.", 0)

HotKeySet("+^!q", "quitty")

If NOT StringInStr (@ScriptName, "[S]") Then
HotKeySet("+^{SPACE}", "nonbreakspace")
EndIf

If NOT StringInStr (@ScriptName, "[N]") Then
HotKeySet("^{NUMPADSUB}", "endash")
EndIf

If NOT StringInStr (@ScriptName, "[M]") Then
HotKeySet("+^{NUMPADSUB}", "emdash")
EndIf

; If NOT StringInStr (@ScriptName, "[-]") Then
; HotKeySet("^-", "hyphdash")
; EndIf

If NOT StringInStr (@ScriptName, "[.]") Then
HotKeySet("!^.", "ellips")
EndIf

If NOT StringInStr (@ScriptName, "[9]") Then
HotKeySet("^9", "singleopen")
EndIf

If NOT StringInStr (@ScriptName, "[0]") Then
HotKeySet("^0", "singleclose")
EndIf

If NOT StringInStr (@ScriptName, "[+9]") Then
HotKeySet("^+9", "doubleopen")
EndIf

If NOT StringInStr (@ScriptName, "[+0]") Then
HotKeySet("^+0", "doubleclose")
EndIf

While 1
    Sleep(100)
WEnd

Func quitty()
Exit
EndFunc

Func nonbreakspace()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($nonbreaker)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

Func endash()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($endasher)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

Func emdash()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($emdasher)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

Func ellips()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($dotter)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

Func singleopen()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($singleopenquote)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

Func singleclose()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($singleclosequote)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

Func doubleopen()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($doubleopenquote)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

Func doubleclose()
$oldclipHTML = _ClipGetHTML ()
$oldclip = ClipGet ()
Sleep ("200")
ClipPut ($doubleclosequote)
Send ("^v")
Sleep ("100")
Local $sHTMLData=$oldclipHTML[7]&$oldclipHTML[0]
_ClipBoard_SendHTML($sHTMLData,$oldclip)
EndFunc

