﻿
#Include <String.au3>

; WARNING !!! ONLY EDIT THE AU3 FILE IN AKELPAD
; 
; _HexToString malfunctions on my Windows 7 computer, so this is the alternative
; but it's important, then, to edit the AU3 file in a Unicode editor only.

$nonbreaker = " " ; _HexToString("a0")
$endasher = "–" ; _HexToString("96")
$emdasher = "—" ; _HexToString("97")
$nbrhyph = "‑" ; _HexToString("E28091")
$dotter = "…" ; _HexToString("85")
$singleopenquote = "‘" ; _HexToString("91")
$singleclosequote = "’" ; _HexToString("92")
$doubleopenquote = "“" ; _HexToString("93")
$doubleclosequote = "”" ; _HexToString("94")
$doublebottomopenquote = "„"

MsgBox (0, "Ten keyboard shortcuts for special characters, version 7 (send)", "Shift+Ctrl+Space = non-breaking space" & @CRLF & "Alt+Ctrl+fullstop = ellips (...)" & @CRLF & "Ctrl+NumMinus = en-dash" & @CRLF & "Shift+Ctrl+NumMinus = em-dash" & @CRLF & "Alt+NumMinus = non-breaking hyphen" & @CRLF & "Ctrl+( = single upper 6-quote (‘)" & @CRLF & "Ctrl+) = single upper 9-quote (or curly apostrophe) (’)" & @CRLF & "Ctrl+Shift+( = double upper 6-quote (“)" & @CRLF & "Ctrl+Shift+) = double upper 9-quote (”)" & @CRLF & 'Ctrl+Shift+" = double bottom 9-quote („)' & @CRLF & @CRLF & "The non-breaking space may not work in a browser text field." & @CRLF & @CRLF & "See the readme.txt file for how to disable shortcuts." & @CRLF & @CRLF & "To exit the script, press Shift+Ctrl+Alt+Q.", 0)

HotKeySet("+^!q", "quitty")

If NOT StringInStr (@ScriptName, "[S]") Then
HotKeySet("+^{SPACE}", "nonbreakspace")
EndIf

If NOT StringInStr (@ScriptName, "[N]") Then
HotKeySet("^{NUMPADSUB}", "endash")
EndIf

If NOT StringInStr (@ScriptName, "[M]") Then
HotKeySet("+^{NUMPADSUB}", "emdash")
EndIf

; Removed due to overlap with MS Word shortcut
; If NOT StringInStr (@ScriptName, "[-]") Then
; HotKeySet("^-", "hyphdash")
; EndIf

If NOT StringInStr (@ScriptName, "[NH]") Then
HotKeySet("+!{NUMPADSUB}", "nbrhyph")
EndIf

If NOT StringInStr (@ScriptName, "[.]") Then
HotKeySet("!^.", "ellips")
EndIf

If NOT StringInStr (@ScriptName, "[9]") Then
HotKeySet("^9", "singleopen")
EndIf

If NOT StringInStr (@ScriptName, "[0]") Then
HotKeySet("^0", "singleclose")
EndIf

If NOT StringInStr (@ScriptName, "[+9]") Then
HotKeySet("^+9", "doubleopen")
EndIf

If NOT StringInStr (@ScriptName, "[+0]") Then
HotKeySet("^+0", "doubleclose")
EndIf

If NOT StringInStr (@ScriptName, "[+quot]") Then
HotKeySet('^+"', "doublebottomclose")
EndIf

While 1
    Sleep(100)
WEnd

Func quitty()
Exit
EndFunc

Func nonbreakspace()
ClipPut ($nonbreaker)
Send ("^v")
EndFunc

Func nbrhyph()
ClipPut ($nbrhyph)
Send ("^v")
EndFunc

Func endash()
ClipPut ($endasher)
Send ("^v")
EndFunc

Func emdash()
ClipPut ($emdasher)
Send ("^v")
EndFunc

; Func hyphdash()
; ClipPut ($endasher)
; Send ("^v")
; EndFunc

Func ellips()
ClipPut ($dotter)
Send ("^v")
EndFunc

Func singleopen()
ClipPut ($singleopenquote)
Send ("^v")
EndFunc

Func singleclose()
ClipPut ($singleclosequote)
Send ("^v")
EndFunc

Func doubleopen()
ClipPut ($doubleopenquote)
Send ("^v")
EndFunc

Func doubleclose()
ClipPut ($doubleclosequote)
Send ("^v")
EndFunc

Func doublebottomclose()
ClipPut ($doublebottomopenquote)
Send ("^v")
EndFunc

